-- Gstion de la fienetre de trace des logs.


majWidth=600;
majHeight= 460;
majLineHeight= 18;

function wMajLabel(lbl,x,y,sz)
	local wL;
	wL = Turbine.UI.Label();
	wL:SetParent(wMajParent);
	wL:SetSize(sz,majLineHeight);
	wL:SetPosition(x,y);
	wL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	wL:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	wL:SetText(lbl);
end

function wMajCheckBox(lbl,x,y,sz)
	local ckb = Turbine.UI.Lotro.CheckBox();
	ckb:SetParent(wMajParent);
	ckb:SetSize(sz,majLineHeight);
	ckb:SetMultiline(false);
	ckb:SetPosition(x,y);
	ckb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	ckb:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	ckb:SetText(lbl);
	return ckb;
end

function wMajToggleAtEvent(c)
	if c:IsChecked() then
		if c ~= wMajStaAvec then wMajStaAvec:SetChecked(false); end
		if c ~= wMajOraAvec then wMajOraAvec:SetChecked(false); end
		if c ~= wMajRedAvec then wMajRedAvec:SetChecked(false); end
		if c ~= wMajLooAvec then wMajLooAvec:SetChecked(false); end
		if c ~= wMajRstAvec then wMajRstAvec:SetChecked(false); end
	end
end

function wMajTextBox(x,y,sz)
	local tb = Turbine.UI.Lotro.TextBox();
	tb:SetParent(wMajParent);
	tb:SetSize(sz,majLineHeight);
	tb:SetPosition(x,y);
	tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	tb:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	tb:SetMultiline(false);
	return tb;
end

function wMajDraw()

	if wMajParent == nil then

		local y;
		
		wMajParent = Turbine.UI.Lotro.Window();
		wMajParent:SetSize(majWidth,majHeight);
		wMajParent:SetVisible(false);
        -- wMajParent:SetBackColor(Turbine.UI.Color(0.85,0,0,0));
        wMajParent:SetZOrder(10000);
		wMajParent:SetText(gSettings.pluginName);


		wMajParent.Closing = function()
			-- wMajParent.visible = false;
		end

		-- nom du chrono
		y = 35;
		wMajLabel(gLang.LABEL,10,y,205);
		wMajInpLbl = wMajTextBox(220,y,150);
		
		-- Demarre  CLICK
		y=y+30;
		wMajLabel(gLang.STARTCLICK,10,y,205);
		wMajLabel(gLang.AT,380,y,50);
		wMajDelClick = wMajTextBox(440,y,50);

		-- Demarre  COMBAT
		y = y+20;
		wMajLabel(gLang.STARTWCBT,10,y,205);
		wMajInpCombat = wMajCheckBox("",220,y,50);
		wMajLabel(gLang.AT,380,y,50);
		wMajDelCombat = wMajTextBox(440,y,50);
		wMajOneCombat = wMajCheckBox(gLang.ONLYONCE,500,y,100);
		
		-- Demarre  TEXTE
		y= y+20;
		wMajLabel(gLang.FIND,10,y,205);
		wMajInpSearch = wMajTextBox(220,y,150);
		wMajInpSearch:SetMultiline(true);
		wMajInpSearch:SetSize(150,majLineHeight*1.5);
		
		wMajLabel(gLang.AT,380,y,50);
		wMajDelSearch = wMajTextBox(440,y,50);
		wMajOneSearch = wMajCheckBox(gLang.ONLYONCE,500,y,100);
		
		-- Demarre  CHRONO
		y=y+30;
		wMajLabel(gLang.STARTWCHR,10,y,205);
		wMajInpAvec = wMajTextBox(220,y,150);
		wMajLabel(gLang.AT,380,y,50);
		wMajDelAvec = wMajTextBox(440,y,50);
		wMajOneAvec = wMajCheckBox(gLang.ONLYONCE,500,y,100);
		-- events asocis au chrono
		local s=70;
		wMajLabel(gLang.ATEVENT,10,y+20,205);
		wMajStaAvec = wMajCheckBox(gLang.ATSTART,220,y+20,s);
		wMajStaAvec.CheckedChanged = function (sender, args)
			wMajToggleAtEvent(wMajStaAvec);
		end
		wMajOraAvec = wMajCheckBox(gLang.ATORANGE,220+s,y+20,s);
		wMajOraAvec.CheckedChanged = function (sender, args)
			wMajToggleAtEvent(wMajOraAvec);
		end
		wMajRedAvec = wMajCheckBox(gLang.ATRED,220+2*s,y+20,s);
		wMajRedAvec.CheckedChanged = function (sender, args)
			wMajToggleAtEvent(wMajRedAvec);
		end
		wMajLooAvec = wMajCheckBox(gLang.ATLOOP,220+3*s,y+20,s);
		wMajLooAvec.CheckedChanged = function (sender, args)
			wMajToggleAtEvent(wMajLooAvec);
		end
		wMajRstAvec = wMajCheckBox(gLang.ATRESET,220+4*s,y+20,s);
		wMajRstAvec.CheckedChanged = function (sender, args)
			wMajToggleAtEvent(wMajRstAvec);
		end
		-- Valeur de orange
		y=y+60;
		wMajLabel(gLang.WARN,10,y,205);
		wMajInpWarn = wMajTextBox(220,y,50);
		-- clignotement orange
		wMajInpBlkOra = wMajCheckBox(gLang.BLINK,290,y,100);

		-- Valeur de rouge
		y=y+20;
		wMajLabel(gLang.ALERT,10,y,205);
		wMajInpAlert = wMajTextBox(220,y,50);
		-- clignotement rouge
		wMajInpBlkRed = wMajCheckBox(gLang.BLINK,290,y,100);
		
		-- Valeur de boucle
		y=y+20;
		wMajLabel(gLang.LOOP,10,y,205);
		wMajInpLoop = wMajTextBox(220,y,50);

		-- valeur de redemarrage de la boucle
		wMajLabel(gLang.LOOPVAL,240,y,190);
		wMajInpLoopVal = wMajTextBox(440,y,50);

		-- reset combat
		y=y+40;
		wMajLabel(gLang.RESETHSCBT,10,y,205);
		wMajInpRstCbt = wMajCheckBox("",220,y,100);
		
		-- valeur de reset
		y=y+20;
		wMajLabel(gLang.RESET,10,y,205);
		wMajInpReset = wMajTextBox(220,y,50);

		-- affichage en mode dcompte
		y=y+35;
		wMajLabel(gLang.ISCNTDWN,10,y,205);
		wMajInpCntDwn = wMajCheckBox("",220,y,50);
		
		-- commentaire libre du chrono
		y=y+35;
		wMajLabel(gLang.DESC,10,y,205);
		wMajInpComment = Turbine.UI.Lotro.TextBox();
		wMajInpComment:SetParent(wMajParent);
		wMajInpComment:SetSize(majWidth-230,2*majLineHeight);
		wMajInpComment:SetMultiline(true);
		wMajInpComment:SetPosition(220,y);
		wMajInpComment:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft);
		wMajInpComment:SetFont(Turbine.UI.Lotro.Font.Verdana16);

-----
		-- dplacement
		y=y+40;
		wMajBtnHaut = Turbine.UI.Lotro.Button();
		wMajBtnHaut:SetParent(wMajParent);
		wMajBtnHaut:SetSize(175,majLineHeight);
		wMajBtnHaut:SetPosition(35,y);
		wMajBtnHaut:SetText(gLang.HAUT);
		wMajBtnHaut.Click = function (sender, args)
			wMajHaut();
		end

		y=y+25;
		wMajBtnBas = Turbine.UI.Lotro.Button();
		wMajBtnBas:SetParent(wMajParent);
		wMajBtnBas:SetSize(175,majLineHeight);
		wMajBtnBas:SetPosition(35,y);
		wMajBtnBas:SetText(gLang.DOWN);
		wMajBtnBas.Click = function (sender, args)
			wMajBas();
		end

-----
		local wMajBtnSupprimer = Turbine.UI.Lotro.Button();
		wMajBtnSupprimer:SetParent(wMajParent);
		wMajBtnSupprimer:SetSize(70,majLineHeight);
		wMajBtnSupprimer:SetPosition(majWidth-270,majHeight-30);
		wMajBtnSupprimer:SetText(gLang.DELETE);
		wMajBtnSupprimer.Click = function (sender, args)
			wMajDelete();
		end


		local wMajBtnAnnuler = Turbine.UI.Lotro.Button();
		wMajBtnAnnuler:SetParent(wMajParent);
		wMajBtnAnnuler:SetSize(70,majLineHeight);
		wMajBtnAnnuler:SetPosition(majWidth-190,majHeight-30);
		wMajBtnAnnuler:SetText(gLang.CANCEL);
		wMajBtnAnnuler.Click = function (sender, args)
			wMajCancel();
		end
		
		local wMajBtnOk = Turbine.UI.Lotro.Button();
		wMajBtnOk:SetParent(wMajParent);
		wMajBtnOk:SetSize(70,majLineHeight);
		wMajBtnOk:SetPosition(majWidth-110,majHeight-30);
		wMajBtnOk:SetText(gLang.UPDATE);
		wMajBtnOk.Click = function (sender, args)
			wMajOk();
		end


--------
		
		
		
	end
end

function wMajFill(chrono)
		-- positionne la fenetre et la rend visible
		local h,v = Turbine.UI.Display.GetMousePosition();
		wMajParent:SetPosition(h,v);
		-- wMajParent:SetText(chrono.lbl);
		Includes.Onscreen(wMajParent);
		
		-- positionne les valeurs
		
		wMajInpLbl:SetText(chrono.lbl);
		wMajInpComment:SetText(chrono.comment);
		wMajInpSearch:SetText(chrono.search);
		wMajInpAvec:SetText(chrono.demarreAvec);
		wMajInpCombat:SetChecked(chrono.demarreCombat);
		wMajInpRstCbt:SetChecked(chrono.resetCombat);
		wMajInpWarn:SetText(Includes.VideSiMoinsUn(chrono.warn));
		wMajInpAlert:SetText(Includes.VideSiMoinsUn(chrono.alert));
		wMajInpReset:SetText(Includes.VideSiZero(chrono.reset));
		wMajInpLoop:SetText(Includes.VideSiZero(chrono.loop));
		wMajInpLoopVal:SetText(Includes.VideSiZero(chrono.loopVal));
		wMajInpCntDwn:SetChecked(chrono.isCountdown);
		wMajInpBlkOra:SetChecked(chrono.isBlinkOrange);
		wMajInpBlkRed:SetChecked(chrono.isBlinkRed);
		wMajDelClick:SetText(Includes.ZeroSiVide(chrono.clickDelay));
		wMajDelCombat:SetText(Includes.ZeroSiVide(chrono.combatDelay));
		wMajDelSearch:SetText(Includes.ZeroSiVide(chrono.searchDelay));
		wMajDelAvec:SetText(Includes.ZeroSiVide(chrono.avecDelay));
		wMajOneCombat:SetChecked(chrono.combatOnce);
		wMajOneSearch:SetChecked(chrono.searchOnce);
		wMajOneAvec:SetChecked(chrono.avecOnce);
		-- Options du startAvec ^^
		wMajStaAvec:SetChecked(chrono.avecEvent == chronoAvecEvent.START);
		wMajOraAvec:SetChecked(chrono.avecEvent == chronoAvecEvent.ORANGE);
		wMajRedAvec:SetChecked(chrono.avecEvent == chronoAvecEvent.RED);
		wMajLooAvec:SetChecked(chrono.avecEvent == chronoAvecEvent.LOOP);
		wMajRstAvec:SetChecked(chrono.avecEvent == chronoAvecEvent.RESET);
		-- Memorise le chrono en cours d'edition
		wMajFillChrono = chrono;

		wMajParent:SetVisible(true);
		wMajHautBasVisibility();
end

function wMajHautBasVisibility()
		-- afficahge des boutons de deplacement...
		local idx = ChronoGetPosition(wMajFillChrono);
		wMajBtnHaut:SetEnabled(idx > 1);
		wMajBtnBas:SetEnabled(idx < #ChronoConfig.chronos);
		 
end

function wMajOk()
		if wMajFillChrono ~= nil then
			wMajFillChrono.lbl = wMajInpLbl:GetText();
			wMajFillChrono.comment = wMajInpComment:GetText();
			wMajFillChrono.search = Includes.trimCR(wMajInpSearch:GetText());
			wMajFillChrono.demarreAvec = Includes.trimCR(wMajInpAvec:GetText());
			wMajFillChrono.demarreCombat = wMajInpCombat:IsChecked();
			wMajFillChrono.resetCombat = wMajInpRstCbt:IsChecked();
			wMajFillChrono.warn = Includes.MoinsUnSiVide(wMajInpWarn:GetText());
			wMajFillChrono.alert = Includes.MoinsUnSiVide(wMajInpAlert:GetText());
			wMajFillChrono.reset = Includes.ZeroSiVide(wMajInpReset:GetText());
			wMajFillChrono.loop = Includes.ZeroSiVide(wMajInpLoop:GetText());
			wMajFillChrono.loopVal = Includes.ZeroSiVide(wMajInpLoopVal:GetText());
			wMajFillChrono.isCountdown = wMajInpCntDwn:IsChecked();
			wMajFillChrono.isBlinkOrange = wMajInpBlkOra:IsChecked();
			wMajFillChrono.isBlinkRed = wMajInpBlkRed:IsChecked();
			wMajFillChrono.clickDelay = Includes.ZeroSiVide(wMajDelClick:GetText());
			wMajFillChrono.combatDelay = Includes.ZeroSiVide(wMajDelCombat:GetText());
			wMajFillChrono.searchDelay = Includes.ZeroSiVide(wMajDelSearch:GetText());
			wMajFillChrono.avecDelay = Includes.ZeroSiVide(wMajDelAvec:GetText());
			wMajFillChrono.combatOnce = wMajOneCombat:IsChecked();
			wMajFillChrono.searchOnce = wMajOneSearch:IsChecked();
			wMajFillChrono.avecOnce = wMajOneAvec:IsChecked();

			-- Options du startAvec ^^
			if wMajOraAvec:IsChecked()  then
				wMajFillChrono.avecEvent = chronoAvecEvent.ORANGE;
			elseif wMajRedAvec:IsChecked() then
				wMajFillChrono.avecEvent = chronoAvecEvent.RED;
			elseif wMajLooAvec:IsChecked() then 
				wMajFillChrono.avecEvent = chronoAvecEvent.LOOP;
			elseif wMajRstAvec:IsChecked() then
				wMajFillChrono.avecEvent = chronoAvecEvent.RESET;
			else
				wMajFillChrono.avecEvent = chronoAvecEvent.START;
			end
			-- Mise  jour du chrono
			wMajFillChrono.control:SetText("0:00:00 " .. wMajFillChrono.lbl  ); 
			ChronoRefresh(wMajFillChrono);
		end
		wMajFillChrono = nil;
		wMajParent:SetVisible(false);
		saveSettings();
end

function wMajDelete()
		ChronoDelete(wMajFillChrono);
		wMajFillChrono = nil;
		wMajParent:SetVisible(false);
		saveSettings();
end

function wMajCancel()
		wMajFillChrono = nil;
		wMajParent:SetVisible(false);
end

function wMajHaut()
		-- deplace le chrono vers le haut dans la liste
		ChronoHaut(wMajFillChrono);
		wMajHautBasVisibility();
end

function wMajBas()
		-- deplace le chrono vers le haut dans la liste
		ChronoBas(wMajFillChrono);
		wMajHautBasVisibility();
end

